#define IAM_MSG     CTA_USER_EVENT(0x00)
#define ACM_MSG     CTA_USER_EVENT(0x01)
#define ANM_MSG     CTA_USER_EVENT(0x02)
#define REL_MSG     CTA_USER_EVENT(0x03)
#define RLC_MSG     CTA_USER_EVENT(0x04)
#define RSC_MSG     CTA_USER_EVENT(0x05)
#define BLO_MSG     CTA_USER_EVENT(0x06)
#define BLA_MSG     CTA_USER_EVENT(0x07)
#define UBL_MSG     CTA_USER_EVENT(0x08)
#define UBA_MSG     CTA_USER_EVENT(0x09)
#define INF_MSG     CTA_USER_EVENT(0x0a)
#define INR_MSG     CTA_USER_EVENT(0x0b)
#define CON_MSG     CTA_USER_EVENT(0x0c)
#define CPG_MSG     CTA_USER_EVENT(0x0d)
#define SUS_MSG     CTA_USER_EVENT(0x0e)
#define RES_MSG     CTA_USER_EVENT(0x0f)
#define SAM_MSG     CTA_USER_EVENT(0x10)
#define GRS_MSG     CTA_USER_EVENT(0x11)
#define CGB_MSG     CTA_USER_EVENT(0x12)
#define CGU_MSG     CTA_USER_EVENT(0x13)

#define IAM_EVT     CTA_USER_EVENT(0x20)
#define ACM_EVT     CTA_USER_EVENT(0x21)
#define ANM_EVT     CTA_USER_EVENT(0x22)
#define REL_EVT     CTA_USER_EVENT(0x23)
#define RLC_EVT     CTA_USER_EVENT(0x24)
#define RSC_EVT     CTA_USER_EVENT(0x25)
#define BLO_EVT     CTA_USER_EVENT(0x26)
#define BLA_EVT     CTA_USER_EVENT(0x27)
#define UBL_EVT     CTA_USER_EVENT(0x28)
#define UBA_EVT     CTA_USER_EVENT(0x29)
#define INF_EVT     CTA_USER_EVENT(0x2a)
#define INR_EVT     CTA_USER_EVENT(0x2b)
#define CON_EVT     CTA_USER_EVENT(0x2c)
#define CPG_EVT     CTA_USER_EVENT(0x2d)
#define SUS_EVT     CTA_USER_EVENT(0x2e)
#define RES_EVT     CTA_USER_EVENT(0x2f)
#define SAM_EVT     CTA_USER_EVENT(0x30)
#define GRS_EVT     CTA_USER_EVENT(0x31)
#define CGB_EVT     CTA_USER_EVENT(0x32)
#define CGU_EVT     CTA_USER_EVENT(0x33)

#define ERR_EVT         CTA_USER_EVENT(0x40)
#define DEAD_EVT        CTA_USER_EVENT(0x41)
#define STARTED_EVT     CTA_USER_EVENT(0x42)
#define BACKUP_EVT      CTA_USER_EVENT(0x43)
#define PRIMARY_EVT     CTA_USER_EVENT(0x44)
#define STANDALONE_EVT  CTA_USER_EVENT(0x45)

#define CHKPNT_EVT      CTA_USER_EVENT(0x46)
#define IDLE_EVT        CTA_USER_EVENT(0x47)
#define APPREADY_EVT    CTA_USER_EVENT(0x48)
#define STOP_EVT        CTA_USER_EVENT(0x49)



#define EVT_TRACE       0x0001
#define CHKPNT_TRACE    0x0002

#define DIR_TX          1
#define DIR_RX          2

/* constants used to interface with ISUP API & MGMT API */
#define INST_ID     0
#define ENT_ID      35
#define MGMT_ENT_ID 36
#define SAP_ID      0


typedef struct checkPointMsg
{
    U32     msgId;
    CirId   cirId;
    CirId   mateId;
    U8      transient;
    U8      callState;
    U8      blkState;

} ChkPntMsg;

#define CHKPNT_MSG  0x434b5054
#define APPRDY_MSG  0x41524459

typedef struct
{
    IsupRcvInfoBlk  info;
    SiAllSdus       sdu;
    ChkPntMsg       chkPntMsg;
} Event;

typedef struct circuit
{
    short       state;
    CTAQUEUEHD  ctaQueue;
    CTAHD       ctaHndl;
    CirId       cirId;
    CirId       mateId;
    SuId        suId;
    SiInstId    suInstId;
    SiInstId    spInstId;
    U8          callState;
    U8          blkState;
    U8          transient;

} Circuit;

typedef struct
{
    char               *stateName;  /* pointer to state name */
    void              (*state)();   /* pointer to state function */
} StateDesc;

DWORD EventCircuit(CirId srcId, CirId dstId, DWORD evtId, Event *event);

