/*****************************************************************************
 * File:		sol-dep.c
 * Objective:   File contains functions to get keyboard input characters.
 *
 *****************************************************************************/
#ifdef UNIX
#ifndef LINUX
#include <stropts.h>
#endif
#include <poll.h>
#include <stdio.h>
#endif

/******************************************************************************
 * Funcltion:   _kbhit
 * Returns: If there is a keyboard input, then function returns 1.
 * Notes: Polling keyboard input.
 */
int _kbhit(void)
{
   int RetCode = 0;
   struct pollfd kbdfd;

   kbdfd.fd = 0; /*input*/
   kbdfd.events = POLLIN;
   kbdfd.revents = 0;

   RetCode = poll(&kbdfd,1,100);
   if (RetCode <= 0) {
      RetCode = 0; /*timeout*/
   } else {
      RetCode = 1;
   }

   return (RetCode);
}

/******************************************************************************
 * Function:   _getch
 * Objective:  get a character from console without echo
 * Returns:    the character read, no error return
 */
int _getch(void)
{
   return (getchar());
}













