#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "nmstypes.h"
#include "ctadef.h"
/*#include "ss7type.h" */
#include "tuptype.h"
#include "tupmsgs.h"
#include "tupdef.h"
#include "osdep.h"

/*API Functions Prototypes*/
DWORD NMSAPI     TUPStatusReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                              CirIdx circuit, U8 eventType, TupStaEvnt *statEvnt);
DWORD NMSAPI     TUPConnectReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                               Bool cirSelFlg, CirIdx circuit, TupConEvnt *conEvnt);
DWORD NMSAPI     TUPConnectStatusReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                                     CirIdx circuit, TupCnStEvnt *conStEvnt, U8 eventType);
DWORD NMSAPI     TUPReleaseResp(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                                CirIdx circuit, TupRelEvnt *relEvnt);
DWORD NMSAPI     TUPReleaseReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                               CirIdx circuit, TupRelEvnt *relEvnt);
DWORD NMSAPI     TUPConnectResp(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                                CirIdx circuit, TupConRspEvnt *conRspEvnt);
U8 NMSAPI     TUPASCIItoADDR(char *ascii, TupTknStr *addrSigs, short length);

DWORD sendIAMwithSubAddr(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit,
                   char *called, char *calling)
{
    DWORD  status;
	TupCnStEvnt tupConStaEvnt;  /* Connect Event */
	TupConEvnt tupConEvnt;  /* Connect Event */
	char lastNum = '0';

    UNREFERENCED_PARAMETER(calling);

	/* clear out connect rqst event buffer to zeros (0 => NOT_PRESENT) */
	memset( &tupConEvnt, 0, sizeof( tupConEvnt ) );

	/* mandatory calling party category */
	tupConEvnt.cgPtyCat.eh.pres      = PRESENT;
	tupConEvnt.cgPtyCat.callPartyCat = (U8)ORDINARY_TOLL_CALLER; /* ordinary subscriber */

	/* mandatory message indicator */
	tupConEvnt.msgInd.eh.pres      = PRESENT;
    tupConEvnt.msgInd.msgInd = 0;
    /*tupConEvnt.msgInd.msgInd = IAM_MI_CONT_CHECK_REQ;*/

	/* called party number */
	tupConEvnt.addrSigs.eh.pres = PRESENT;
	TUPASCIItoADDR( called, &tupConEvnt.addrSigs.addrSigs, (short)strlen(called) );

	/* send the CONNECT RQST */
    status = TUPConnectReq(ctahd, board, spId, suInstId, spInstId,
                           (Bool)((circuit) ? 1 : 0), circuit, &tupConEvnt );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectReq() failed in sendIAM(), status = %d\n", status );
	}
	else
	{
		printf( "Connect Rqst (IAM) sent for circuit %d\n", circuit );
	}

	/* clear out connect rqst event buffer to zeros (0 => NOT_PRESENT) */
    memset( &tupConStaEvnt, 0, sizeof( tupConStaEvnt ) );

	/* mandatory calling party category */
    tupConStaEvnt.cgPtyCat.eh.pres      = PRESENT;
    tupConStaEvnt.cgPtyCat.callPartyCat = (U8)ORDINARY_TOLL_CALLER; /* ordinary subscriber */

	/* called party number */
    tupConStaEvnt.origCdNum.eh.pres = PRESENT;
    tupConStaEvnt.origCdNum.addrInd = (TUPSUBSNUM | TUPNOTRES | TUPNOTINC); /* Address indicators */
    TUPASCIItoADDR( called, &tupConStaEvnt.origCdNum.addrSigs, (short)strlen(called));

	/* send the CONNECT RQST */
    status = TUPConnectStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, &tupConStaEvnt, TUPSUBSADDR );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectStatusReq() failed in sendIAMwithSubAddr(), status = %d\n", status );
	}
	else
	{
		printf( "Subsequence address (SAM) sent for circuit %d\n", circuit );
	}

    TUPASCIItoADDR( &lastNum, &tupConStaEvnt.origCdNum.addrSigs, 1);

	/* send the CONNECT RQST */
    status = TUPConnectStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, &tupConStaEvnt, TUPSUBSADDR );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectStatusReq() failed in sendIAMwithSubAddr(), status = %d\n", status );
	}
	else
	{
		printf( "Subsequence address (SAO) sent for circuit %d\n", circuit );
    }

    return(status);
}

DWORD sendIAM1(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit,
                   char *called, char *calling)
{
    DWORD  status;
    TupConEvnt tupConEvnt;  /* Connect Event */

    UNREFERENCED_PARAMETER(calling);


	/* clear out connect rqst event buffer to zeros (0 => NOT_PRESENT) */
	memset( &tupConEvnt, 0, sizeof( tupConEvnt ) );

	/* mandatory calling party category */
	tupConEvnt.cgPtyCat.eh.pres      = PRESENT;
	tupConEvnt.cgPtyCat.callPartyCat = (U8)ORDINARY_TOLL_CALLER; /* ordinary subscriber */

	/* mandatory message indicator */
	tupConEvnt.msgInd.eh.pres      = PRESENT;
    tupConEvnt.msgInd.msgInd = 0;
    /*tupConEvnt.msgInd.msgInd = IAM_MI_OUT_ECHO_SUPP_INCLUDED;*/
    /*tupConEvnt.msgInd.msgInd = IAM_MI_CONT_CHECK_REQ;*/

	/* called party number */
	tupConEvnt.addrSigs.eh.pres = PRESENT;
	TUPASCIItoADDR( called, &tupConEvnt.addrSigs.addrSigs, (short)strlen(called) );

	/* send the CONNECT RQST */
    status = TUPConnectReq(ctahd, board, spId, suInstId, spInstId,
                           (Bool)((circuit) ? 1 : 0), circuit, &tupConEvnt );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectReq() failed in sendIAM(), status = %d\n", status );
	}
	else
	{
		printf( "Connect Rqst (IAM) sent for circuit %d\n", circuit );
    }

    return(status);
}


DWORD sendResetReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
    DWORD            status;
	TupStaEvnt       evnt;

	/* initialize message  */
	memset(&evnt, 0, sizeof(evnt));

	/* send */
    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCIRRESREQ, &evnt);

	if( status != TUP_SUCCESS )
	{
		printf("TUPStatusReq() failed in sendResetReq, status = %d\n", status);
	}
	else
	{
		printf("Reset request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendGroupBlockReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit,
                        U8 range, U8 *statusMap)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

	evnt.range.eh.pres     = PRESENT;
	evnt.range.range = range;
	if (range != 0)
		memcpy(evnt.range.statusMap, statusMap, (range + 1));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCRMGRPBLKREQ, &evnt);

	if (status != TUP_SUCCESS)
	{
		printf("TUPStatusReq() failed in sendGroupBlockReq(), status = %d\n", status);
	}
	else
	{
		printf("Group block request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendGroupUnblockReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId,
                          CirIdx circuit, U8 range, U8 *statusMap)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

	evnt.range.eh.pres     = PRESENT;
	evnt.range.range = range;
	if (range != 0)
		memcpy(evnt.range.statusMap, statusMap, (range + 1));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCRMGRPUNBLKREQ, &evnt);

	if (status != TUP_SUCCESS)
	{
		printf("TUPStatusReq() failed in sendUngroupBlockReq(), status = %d\n", status);
	}
	else
	{
		printf("Group unblock request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendBlockReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCIRBLKREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
		printf("TUPStatusReq() failed in sendBlockReq(), status = %d\n", status);
	}
	else
	{
		printf("Block request sent for circuit %d\n", circuit);
	}
    return (status);
}


DWORD sendUnblockReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCIRUNBLKREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
		printf("TUPStatusReq() failed in sendUnblockReq(), status = %d\n", status);
	}
	else
	{
		printf("Unblock request sent for circuit %d\n", circuit);
	}
    return (status);
}


DWORD sendIAM(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
    DWORD  status;
	TupConEvnt tupConEvnt;  /* Connect Event */
	char called[11]= "2125551212";

	/* clear out connect rqst event buffer to zeros (0 => NOT_PRESENT) */
	memset( &tupConEvnt, 0, sizeof( tupConEvnt ) );


	/* mandatory calling party category */
	tupConEvnt.cgPtyCat.eh.pres      = PRESENT;
    tupConEvnt.cgPtyCat.callPartyCat = (U8)TEST_CALL; /* test call */

	/* mandatory message indicator */
	tupConEvnt.msgInd.eh.pres      = PRESENT;
    tupConEvnt.msgInd.msgInd = 0;
    /*tupConEvnt.msgInd.msgInd = IAM_MI_CONT_CHECK_REQ;*/

	/* called party number */
	tupConEvnt.addrSigs.eh.pres = PRESENT;
    TUPASCIItoADDR( called, &tupConEvnt.addrSigs.addrSigs, 10 );

	/* send the CONNECT RQST */
    status = TUPConnectReq(ctahd, board, spId, suInstId, spInstId,
                           (Bool)((circuit) ? 1 : 0), circuit, &tupConEvnt );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectReq() failed in sendIAM(), status = %d\n", status );
	}
	else
	{
		printf( "Connect Rqst (IAM) sent for circuit %d\n", circuit );
	}
    return (status);

}

DWORD sendInfoResp(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit,
                   char *called, char *calling)
{
    DWORD  status;
	TupCnStEvnt tupConStaEvnt;  /* Connect Event */

    UNREFERENCED_PARAMETER(called);

	/* clear out connect rqst event buffer to zeros (0 => NOT_PRESENT) */
	memset( &tupConStaEvnt, 0, sizeof( tupConStaEvnt ) );

	/* mandatory calling party category */
	tupConStaEvnt.cgPtyCat.eh.pres      = PRESENT;
	tupConStaEvnt.cgPtyCat.callPartyCat = (U8)ORDINARY_TOLL_CALLER; /* ordinary subscriber */

	/* if caller specified a calling pty number, include it */
	if (calling)
	{
		tupConStaEvnt.cgPtyNum.eh.pres = PRESENT;
        tupConStaEvnt.cgPtyNum.addrInd = (TUPSUBSNUM | TUPNOTRES | TUPNOTINC); /* Address indicators */
        TUPASCIItoADDR( calling, &tupConStaEvnt.cgPtyNum.addrSigs, (short)strlen(calling) );
	}

	/* called party number */
	tupConStaEvnt.origCdNum.eh.pres = PRESENT;
    tupConStaEvnt.origCdNum.addrInd = (TUPSUBSNUM | TUPNOTRES | TUPNOTINC); /* Address indicators */
    TUPASCIItoADDR( calling, &tupConStaEvnt.origCdNum.addrSigs, (short)strlen(calling) );

	/* send the CONNECT RQST */
    status = TUPConnectStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, &tupConStaEvnt, TUPINFORMATION );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectReq() failed in sendIAM(), status = %d\n", status );
	}
	else
	{
		printf( "Connect Rqst (IAM) sent for circuit %d\n", circuit );
	}
    return(status);
}

DWORD sendReleaseRsp(CTAHD ctahd, U8 board, TupRelEvnt *evnt, TupRcvInfoBlk *infoBlk)
{
    DWORD status;

   /* log receipt of message (assumes mandatory cause indicator is
    * present.
    */
	printf( "Release received, circ=%d, suId=%d, spId=%d, cause=%d\n",
			infoBlk->circuit, infoBlk->suInstId, infoBlk->spInstId,
			evnt->cause );

   /* For ANSI, no parameters to release complete, so just use
    * incoming event as dummy release event (for CCITT, need to set
    * cause IE as desired before sending rel comp)
    */
    status = TUPReleaseResp( ctahd, board, 0, infoBlk->suInstId,
							  infoBlk->spInstId, infoBlk->circuit, evnt );

	if (status != TUP_SUCCESS)
	{
		printf("TUPReleaseResp() failed status = %d\n", status);
	}
	else
	{
		printf("Release Complete sent for circuit %d\n", infoBlk->circuit);
    }
    return(status);
}

DWORD sendRelRsp(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
    DWORD status;
    TupRelEvnt       tupRelEvnt;

    UNREFERENCED_PARAMETER(spId);

	/* clear out release event buffer to zeros (0 => NOT_PRESENT) */
    memset(&tupRelEvnt, 0, sizeof(tupRelEvnt));


 /* log receipt of message (assumes mandatory cause indicator is
  * present.
  */

 /* For TUP, no parameters to circuit Free, so just use
  * incoming event as dummy release event.
  */
    status = TUPReleaseResp( ctahd, board, 0, suInstId,
                             spInstId, circuit, &tupRelEvnt );

    if (status != TUP_SUCCESS)
	{
        printf("TUPReleaseResp() failed status = %d\n", status);
	}
	else
    {
	printf("Release Response sent for circuit %d\n", circuit);
    }
    return (status);
}


DWORD sendReleaseReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
    DWORD           status;
	TupRelEvnt       evnt;

	/* clear out release event buffer to zeros (0 => NOT_PRESENT) */
	memset(&evnt, 0, sizeof(evnt));

    /* Fill in Release Cause field, if neccessary */
    /*evnt.cause.eh.pres = PRESENT;
    evnt.cause.cause = TUPSWITCHCONG;  */

	/* send the REL */
    status = TUPReleaseReq(ctahd, board, spId, suInstId, spInstId, circuit, &evnt);

	if (status != TUP_SUCCESS)
	{
		printf("TUPReleaseReq() failed status = %d\n", status );
	}
	else
	{
        /*printf("Release sent for circuit %d, spInstId %d\n", circuit, spInstId );*/
	}
    return(status);
}

DWORD sendACM(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupCnStEvnt      addrcmp;
    DWORD            status;

	/* initialize ACM message by copying parameters from original
	 * connect indication (IAM) received
	 */
	memset( &addrcmp, 0, sizeof( addrcmp ) );

	/* send the ACM */
    status = TUPConnectStatusReq( ctahd, board, spId, suInstId, spInstId, circuit, &addrcmp, TUPADDRCMPLT );
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectStatusReq() failed status = %d\n", status );
	}
    else
	{
        printf( "Address Complete sent for circuit %d\n", circuit );
    }
    return(status);
}       /* end of sendAddressComplete */


DWORD sendAnswer(CTAHD ctahd, U8 board, TupConRspEvnt *eevnt, TupRcvInfoBlk *infoBlk)
{
    DWORD           status;
	TupConRspEvnt   evnt;

    UNREFERENCED_PARAMETER(eevnt);

	evnt.answerType.eh.pres = 1;
	evnt.answerType.answerType = ANU_CHARGE;

    status = TUPConnectResp(ctahd, board, infoBlk->suId, infoBlk->suInstId,
                            infoBlk->spInstId, infoBlk->circuit, &evnt);
	if( status != TUP_SUCCESS )
	{
		printf( "TUPConnectResp() failed status = %d\n", status );
	}
    else
	{
		printf( "Answer sent for circuit %d\n", infoBlk->circuit );
    }
    return(status);
}

DWORD sendCircuitResetReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCIRRESREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendCircuitResetReq(), status = %d\n", status);
	}
	else
	{
        printf("Reset request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendGrpCircuitResetReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;
    short        i;

	memset(&evnt, 0, sizeof(evnt));

    evnt.range.eh.pres = PRESENT;
    evnt.range.range = 23;

    for ( i = 0; i<= evnt.range.range; i++)
        evnt.range.statusMap[i] = 1;


    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCIRGRPRESREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendGrpCircuitResetReq(), status = %d\n", status);
	}
	else
	{
        printf("Group Circuit Reset request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendContinuityCheckReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCONTCHK, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendContinuityCheckReq(), status = %d\n", status);
	}
	else
	{
        printf("Continuity Check test request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendContinuityFailure(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCONFAIL, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendContinuityFailure(), status = %d\n", status);
	}
	else
	{
        printf("Continuity Failure sent for circuit %d\n", circuit);
	}
    return (status);
}


DWORD sendSwitchEqpCongestion(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPSWITCHCONG, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendSwitchEqpCongestion(), status = %d\n", status);
	}
	else
	{
        printf("Switch Equipment Congestion sent for circuit %d\n", circuit);
	}
    return (status);
}


DWORD sendCirGrpCongestion(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCIRCUITCONG, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendCirGrpCongestion(), status = %d\n", status);
	}
	else
	{
        printf("Circuit Group Congestion sent\n");
	}
    return (status);
}


DWORD sendNationNwkCongestion(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPNATIONALCONG, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendNationNwkCongestion(), status = %d\n", status);
	}
	else
	{
        printf("Nation Network Congestion sent\n");
	}
    return (status);
}

DWORD sendAddrIncomplete(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPADDRESSINCOMP, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendAddrIncomplete(), status = %d\n", status);
	}
	else
	{
        printf("Address Incomplete sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendCallFailure(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCALLFAILURE, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendCallFailure(), status = %d\n", status);
	}
	else
	{
        printf("Call Failure sent for circuit %d\n", circuit);
	}
    return (status);
}


DWORD sendSubscriberBusy(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPSUBBUSY, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendSubscriberBusy(), status = %d\n", status);
	}
	else
	{
        printf("Subscriber Busy sent for circuit %d\n", circuit);
	}
    return (status);
}


DWORD sendUnallocatedNumber(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPUNALLOCATEDNUM, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendUnallocatedNumber(), status = %d\n", status);
	}
	else
	{
        printf("Unallocated Number message sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendLineOutOfSerivce(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPOUTOFSERVICE, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendLineOutOfSerivce(), status = %d\n", status);
	}
	else
	{
        printf("Line Out Of Service message sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendSpecialInfoTone(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPSENDSPECIAL, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendSpecialInfoTone(), status = %d\n", status);
	}
	else
	{
        printf("Special Information Tone message sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendAccessBarred(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPACCESSBARRED, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendAccessBarred(), status = %d\n", status);
	}
	else
	{
        printf("Access Barred message sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendNoDigitalPath(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPNODIGITAL, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendNoDigitalPath(), status = %d\n", status);
	}
	else
	{
        printf("Digital Path Not Provided message sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendContinuityReport(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;

	memset(&evnt, 0, sizeof(evnt));

    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCONTREP, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendContinuityReport(), status = %d\n", status);
	}
	else
	{
        printf("Continuity response sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendHardwareCirGrpBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;
    short        i;

	memset(&evnt, 0, sizeof(evnt));

    evnt.range.eh.pres = PRESENT;
    evnt.range.range = 23;

    for ( i = 0; i<= evnt.range.range; i++)
        evnt.range.statusMap[i] = 1;


    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCRHGRPBLKREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendHardwareCirGrpBlkReq(), status = %d\n", status);
	}
	else
	{
        printf("Hardware Circuit Group Block request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendHwCirGrpUnBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;
    short        i;

	memset(&evnt, 0, sizeof(evnt));

    evnt.range.eh.pres = PRESENT;
    evnt.range.range = 23;

    for ( i = 0; i<= evnt.range.range; i++)
        evnt.range.statusMap[i] = 1;


    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCRHGRPUNBLKREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendHardwareCirGrpUnBlkReq(), status = %d\n", status);
	}
	else
	{
        printf("Hardware Circuit Group Unblock request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendMaintCirGrpBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;
    short        i;

	memset(&evnt, 0, sizeof(evnt));

    evnt.range.eh.pres = PRESENT;
    evnt.range.range = 23;

    for ( i = 0; i<= evnt.range.range; i++)
        evnt.range.statusMap[i] = 1;


    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCRMGRPBLKREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendMaintCirGrpBlkReq(), status = %d\n", status);
	}
	else
	{
        printf("Maint Circuit Group Block request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendMaintCirGrpUnBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit)
{
	TupStaEvnt   evnt;
    DWORD        status;
    short        i;

	memset(&evnt, 0, sizeof(evnt));

    evnt.range.eh.pres = PRESENT;
    evnt.range.range = 23;

    for ( i = 0; i<= evnt.range.range; i++)
        evnt.range.statusMap[i] = 1;


    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, circuit, TUPCRMGRPUNBLKREQ, &evnt);
	if(status != TUP_SUCCESS)
	{
        printf("TUPStatusReq() failed in sendMaintCirGrpUnBlkReq(), status = %d\n", status);
	}
	else
	{
        printf("Maint Circuit Group Unblock request sent for circuit %d\n", circuit);
	}
    return (status);
}

DWORD sendCBK(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, U32 cirId)
{
    DWORD            status;
	TupStaEvnt       evnt;

	/* initialize message  */
	memset(&evnt, 0, sizeof(evnt));

	/* send */
    status = TUPStatusReq(ctahd, board, spId, suInstId, spInstId, cirId, TUPCLEARBKW, &evnt);

	if( status != TUP_SUCCESS )
	{
		printf("TUPStatusReq() failed in sending CBK, status = %d\n", status);
	}
	else
	{
		printf("CBK sent for circuit %d\n", cirId);
	}
    return (status);
}

