/*
 * term.c - sample call termination application
 *
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef WIN32
#include <conio.h>
#endif

#ifdef UNIX
#define _getch getchar
#endif

#include "nmstypes.h"
#include "ctadef.h"
#include "txcpi.h"
#include "tuptype.h"
#include "tupmsgs.h"
#include "tupdef.h"
#include "osdep.h"

#ifdef UNIX
#include "sol-dep.h"
#endif /* UNIX */

extern CPI_WAIT_TYPE stdInput;
short waitCOT = FALSE;

#ifdef UNIX
#include <unistd.h>
#define _getch getchar
#define Sleep(x) usleep(x * 1000)
#endif

/* function prototypes from subs.c */
DWORD sendIAM(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);

DWORD sendGroupBlockReq(CTAHD ctahd, U8 board, TupSuId suId, TupInstId suInstId, TupInstId spInstId,
                       CirIdx circuit, U8 range, U8 *status);
DWORD sendGroupUnblockReq(CTAHD ctahd, U8 board, TupSuId suId, TupInstId suInstId, TupInstId spInstId,
                         CirIdx circuit, U8 range, U8 *status);
DWORD sendACM(CTAHD ctahd, U8 board, TupSuId suId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendAnswer(CTAHD ctahd, U8 board, TupAllSdus *evnt, TupRcvInfoBlk *infoBlk);
DWORD sendReleaseReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendReleaseRsp(CTAHD ctahd, U8 board, TupRelEvnt *evnt, TupRcvInfoBlk *infoBlk);
DWORD sendRelRsp(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendBlockReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendUnblockReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendCircuitResetReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendGrpCircuitResetReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendContinuityCheckReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendContinuityFailure(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendSwitchEqpCongestion(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendCirGrpCongestion(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendNationNwkCongestion(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendAddrIncomplete(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendCallFailure(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendSubscriberBusy(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendUnallocatedNumber(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendLineOutOfSerivce(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendSpecialInfoTone(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendAccessBarred(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendNoDigitalPath(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendHardwareCirGrpBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendHwCirGrpUnBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendMaintCirGrpBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendMaintCirGrpUnBlkReq(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, CirIdx circuit);
DWORD sendCBK(CTAHD ctahd, U8 board, TupSpId spId, TupInstId suInstId, TupInstId spInstId, U32 cirId);
DWORD NMSAPI     TUPRetrieveMessage(CTAHD ctahd, TupAllSdus *event, TupRcvInfoBlk *infoBlk);
DWORD NMSAPI     TUPGetApiStats( CTAHD ctahd, TUPAPISTATS *pstats, U8 bReset );
U8 NMSAPI        TUPADDRtoASCII( TupTknStr *addrSigs, char *ascii);

/* globals */

U8 boardNum = 1;
CirIdx circuit = 1;
TupInstId suInstId;
TupInstId spInstId;
TupSuId   suId;
TupAllSdus   rcvEvent;
TupRcvInfoBlk      rcvInfo;
TupAllSdus GlobalrcvEvent;
TupRcvInfoBlk GlobalrcvInfo;
U16 poolsize = 200;
TUPAPISTATS apiStats;
long  delay_time = 0;     /* Introducing delay to process the incoming messages for Queue congestion*/

/* Define Instance and Entity IDs required of any application that
 * utilized the TUP API.
 */

#define ENT_ID     0x22
#define INST_ID    0       /* Always 0 */

/* This application always uses tup sap 0 */
#define SAP_ID      0


extern short stdioHandler(int fd, short events);

/* internal function prototypes */
void handleStatInd(CTAHD ctahd, TupAllSdus *event, TupRcvInfoBlk *infoBlk );

/* handleTupMessage
 *
 * This function is called to handle all incoming TUP messages.
 * It just calls the proper message handling function based on the
 * type of message received.
 */
DWORD handleTupMessage(CTAHD ctahd)
{
    DWORD status;
    unsigned short msgInd;

    char               addressStr[21];

    TupTknStr          *cdAddress = &rcvEvent.m.conEvnt.addrSigs.addrSigs;

    if( delay_time != 0 )
       Sleep( delay_time );
    if ((status = TUPRetrieveMessage( ctahd, &rcvEvent, &rcvInfo )) != TUP_SUCCESS) {
        if ( status != TUP_NOMSG )  /* NOMSG is valid - could be congestion indication */
           fprintf(stderr, "TUPRetrieveMessage() failed, returned %d\n", status);
        return ( TUP_NOMSG );
    }

	/* determine indication/confirmation type received */
	switch( rcvInfo.indType ) {

      case EVTTUPCONCFM:                              /* connect confirmation */
		printf("term: Unexpected Connect Confirmation for circuit %d\n", rcvInfo.circuit);
		break;

      case EVTTUPCONIND:                              /* connect indication (incoming call) */
        waitCOT = 0;
        printf("Length of Address string = %d\n",rcvEvent.m.conEvnt.addrSigs.addrSigs.len);
        TUPADDRtoASCII(cdAddress, addressStr);
        printf("Address string = %s\n", addressStr);
		msgInd = rcvEvent.m.conEvnt.msgInd.msgInd & 0x30;
		printf("term: Connect Indication received for circuit %d ind %x\n", rcvInfo.circuit, msgInd);

        if ( ( msgInd == 0x20 ) || ( msgInd == 0x10 ) )
		{
			printf("Waiting for continuity check to finish!\n");
            waitCOT = 1;                           /* wait for a COT check */
        }
        else
		{
            sendACM(ctahd, boardNum, rcvInfo.suId, rcvInfo.suInstId, rcvInfo.spInstId, rcvInfo.circuit);
            sendAnswer(ctahd, boardNum, &rcvEvent, &rcvInfo);
        }
        break;

      case EVTTUPCNSTIND:                             /* connect status indication */
        printf("term: Connect Status Indication for circuit %d, event %d\n", rcvInfo.circuit, rcvInfo.evntType);
        break;

      case EVTTUPRELIND:                              /* Release indication */
        printf("term: Release Indication received for circuit %d\n", rcvInfo.circuit);
        sendReleaseRsp(ctahd, boardNum, &rcvEvent.m.relEvnt, &rcvInfo);
        break;

      case EVTTUPRELCFM:                              /* Release confirmation (release complt) */
        printf("term: Release Confirmation received for circuit %d\n", (int) rcvInfo.circuit );
        printf("term: Circuit %d released\n", (int) rcvInfo.circuit );
        break;

      case EVTTUPMGTSTAIND:                           /* mgmt status indication */
      case EVTTUPSTAIND:                              /* status indication */
        handleStatInd( ctahd, &rcvEvent, &rcvInfo );
		break;

      case EVTTUPBNDCFM :                            /* Bind confirmation */
        printf("Bind confirm received\n");
        break;

      default:
		/* unrecognized event */
		printf("term: Unrecognized indication [%d] for circuit %d\n", (int) rcvInfo.indType, (int) rcvInfo.circuit );
		break;

	}       /* end switch */

    return(TUP_SUCCESS);

}       /* end handleTupMessage */

/* handleStatInd
*
* This function handles a status indication from the far exchange
* or TUP layer. A ERRORIND indicates that the call has failed, so
* the application terminates. Other indications are just logged (a real
* application would need to respond to some of these indications, such
* as circuit/group blocking/unblocking requests).
*/
void handleStatInd( CTAHD ctahd, TupAllSdus *event, TupRcvInfoBlk *infoBlk )
{

	switch (infoBlk->evntType)
	{

      case TUPERRORIND:   /* ERROR indication from TUP layer */
		printf("term: ERROR Status, circ=%d, suId=%d, spId=%d, indicator=%d\n",
					infoBlk->circuit, (int) infoBlk->suInstId, (int) infoBlk->spInstId,
					(int) event->errInfo.errorCode );
		break;

      case TUPCONTCHK:           /* continuity check requested */
		waitCOT = 2;
		printf("term: Unexpected Continuity Check Rqst Rcvd, circ=%d, suId=%d, spId=%d\n",
				infoBlk->circuit, (int) infoBlk->suInstId, (int) infoBlk->spInstId );
		break;

      case TUPCONTREP:
		if ( waitCOT == 1 )
		{
            sendACM(ctahd, boardNum, infoBlk->suId, infoBlk->suInstId, infoBlk->spInstId, infoBlk->circuit);
            sendAnswer(ctahd, boardNum, event, infoBlk);
			waitCOT = FALSE;
		}
		else if ( waitCOT == 2 )
			printf("term: Expected Continuity Response Rcvd, circ=%d, suId=%d, spId=%d\n",
				infoBlk->circuit, (int) infoBlk->suInstId, (int) infoBlk->spInstId );
		else printf("term: Unexpected Continuity Response Rcvd, circ=%d, suId=%d, spId=%d\n",
				infoBlk->circuit, (int) infoBlk->suInstId, (int) infoBlk->spInstId );
		waitCOT = 0;
		break;
      case TUPCONFAIL:
		if ( waitCOT != 0 )
			printf("term: Expected Continuity Msg - Failure Message circuit %d", infoBlk->circuit);
		else
			printf("term: Unexpected Continuity Failure Message circuit %d", infoBlk->circuit);
		waitCOT = 0;
		break;

      case TUPCIRBLKREQ:
		printf("term: Unexpected Circuit Block Request, circuit %d", infoBlk->circuit);
		break;

      case TUPCIRUNBLKREQ:
		printf("term: Unexpected Circuit Unblock Request, circuit %d", infoBlk->circuit);
		break;

      case TUPCIRRESREQ:
		printf("term: Circuit Reset circuit %d.\n", infoBlk->circuit);
		break;

      case TUPCIRGRPRESREQ:
        printf("term: Circuit Group Reset, starting at circuit %d.\n", infoBlk->circuit);
		break;

      case TUPCRMGRPBLKREQ :
         printf("term: Maint. Group Block received, starting at circuit %d.\n", infoBlk->circuit);
         break;

      case TUPCRMGRPUNBLKREQ :
         printf("term: Maint. Group Block received, starting at circuit %d.\n", infoBlk->circuit);
         break;

      case TUPCRHGRPBLKREQ :
        printf("term: Hardware Group Block received, starting at circuit %d.\n", infoBlk->circuit);
        break;

      case TUPCRHGRPUNBLKREQ :
        printf("term: Hardware Group Unblock received, starting at circuit %d.\n", infoBlk->circuit);
        break;

      case TUPMTP3RESUME:
        printf("term: MTP3 Resume Received: PointCode %x.\n", event->m.staEvnt.pointCode.pointCode);
		break;

      case TUPMTP3PAUSE:
        printf("term: MTP3 Pause Received: PointCode %x.\n", event->m.staEvnt.pointCode.pointCode);
        break;

      case TUPMTP3PAUSETMREXP :
        printf("term: MTP3 Pause timer popped: PointCode %x, Clean up circuit table\n", event->m.staEvnt.pointCode.pointCode);
        break;

      case TUPMTP3STANDALONE :
        printf("term: MTP3 Standalone Received: PointCode.\n");
        break;

      case TUPMTP3PRIMARY :
        printf("term: MTP3 Primary Received: PointCode %x.\n", event->m.staEvnt.pointCode.pointCode);
        break;

      case TUPMTP3BACKUP :
        printf("term: MTP3 Backup Received: PointCode %x.\n", event->m.staEvnt.pointCode.pointCode);
        break;

      default:        /* all other status indications */
		printf("term: Unexpected Status received, circ=%d, suInstId=%d, spInstId=%d, type=%d\n",
				infoBlk->circuit, (int) infoBlk->suInstId, (int) infoBlk->spInstId,
				(int) infoBlk->evntType );
		break;

   }    /* switch */

} /* end of handleStatInd */

static void ErrorAndExit( DWORD ErrId, char *Fcn )
{

   printf( "Error : (%d) error returned in (%s) call.\n", ErrId, Fcn );
   exit( 1 );
}


DWORD NMSSTDCALL ErrHdlr( CTAHD ctahd, DWORD errorcode, char *errtxt, char *func )
{
    /* print out the error and exit */
    char text[40];
    ctaGetText(ctahd, errorcode, text, sizeof(text) );
    if ( errorcode != TUP_NOMSG) {
        printf( "ErrorHandler: %s on ctahd=%#x, %s\n", errtxt, ctahd, func );
        return errorcode;
    }
    return (TUP_SUCCESS);
}

/* main()
 *
 * This is the main routine for the TUP incoming test application.
 * It initializes the application's local circuit state database,
 * initializes the TUP API (by binding to TUP), and then just loops
 * waiting for messages from TUP and dispatching the appropriate
 * routine to handle the message.
 */

int main( int argc, char *argv[] )
{
    short   optind = 1;
	char   *str;

    CTA_SERVICE_DESC tupOpenSvcLst[] = {{{"TUP", "TUPMGR"}, {0}, {0}, {0}}};
    char *tupCloseSvcLst[] = { "TUP" };

    CTAQUEUEHD      FstQueue = 0;
    CTAHD           FstCtaHd = NULL_CTAHD;
    CTA_EVENT         Event;
    DWORD           Ret;
    CTA_INIT_PARMS      tupInitparms =                 { 0 };
    CTA_SERVICE_NAME    tupServiceNames[] =            { { "TUP", "TUPMGR" } };
    U8         inloop = 1;
    int         c;
    CTA_REV_INFO     info;

    UNREFERENCED_PARAMETER(argc);

    ctaGetVersion(&info, sizeof(CTA_REV_INFO));
    if (info.compatlevel != CTA_COMPATLEVEL)
    {
       printf("CTA compatibility level does not match. re-compile.\n");
       exit(1);
    }

    str = argv[optind];
    if (str)
	{
      if (*str == '-')
      {
		optind++;
		switch (*++str)
		{
          case 'b':   /* which channel should we speak through */
			if (*++str)         /* was there a space ? */
               boardNum = (U8)atoi(str);
			else
               boardNum = (U8)atoi(argv[optind++]);
			break;
          case 's' :
            if (*++str)         /* was there a space ? */
               delay_time = atol(str);
			else
               delay_time = atol(argv[optind++]);
            if( delay_time == 0 )
               printf( "Warning: Invalid delay time [%s] specified, using 0\n", delay_time);
            break;

          default:
			printf( "Usage: %s [-b <board>] \n", argv[0] );
			exit(1);
		}
      }
	}

    /*ctaSetErrorHandler(ErrHdlr, NULL);*/

    /* bind this application as a user of the TUP layer */
    tupInitparms.size = sizeof(CTA_INIT_PARMS);
    tupInitparms.traceflags = CTA_TRACE_ENABLE;
    tupInitparms.parmflags  = CTA_PARM_MGMT_SHARED;
    tupInitparms.ctacompatlevel = CTA_COMPATLEVEL;

    Ret = ctaInitialize( tupServiceNames,
                         sizeof(tupServiceNames) / sizeof(tupServiceNames[0]),
                         &tupInitparms);
    if (Ret != SUCCESS)
    {
       /*-----------------3/7/00 10:58AM-------------------
        * ctdaemon is not running. Initialize
        * without tracing
        * --------------------------------------------------*/
       tupInitparms.traceflags = 0;
       tupInitparms.parmflags  = 0;
       Ret = ctaInitialize( tupServiceNames,
                            sizeof(tupServiceNames) / sizeof(tupServiceNames[0]),
                            &tupInitparms);
       if ( Ret != SUCCESS)
       {
           ErrorAndExit( Ret, "ctaInitialize" );
       }
    }

    Ret = ctaCreateQueue( NULL, 0, &FstQueue );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaCreateQueue" );
    }

    /* Open FstCtaHd on FstQueue                   */
    Ret = ctaCreateContext( FstQueue, 0, NULL, &FstCtaHd );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaCreateContext" );
    }

    tupOpenSvcLst[0].svcargs.args[0] = boardNum;     /* board number */
    tupOpenSvcLst[0].svcargs.args[1] = INST_ID;      /* srcInst */
    tupOpenSvcLst[0].svcargs.args[2] = ENT_ID;       /* dprChan */
    tupOpenSvcLst[0].svcargs.args[3] = 1;            /* AutoBind? (yes=1, no= 0) */
    tupOpenSvcLst[0].svcargs.args[4] = SAP_ID;       /* spId */
    tupOpenSvcLst[0].svcargs.args[5] = SAP_ID;       /* suId */
    tupOpenSvcLst[0].svcargs.args[6] = poolsize;       /* pool size */

    Ret = ctaOpenServices( FstCtaHd, tupOpenSvcLst, 1 );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaOpenServices" );
    }

    /* Wait for service open to complete. */
    Ret = ctaWaitEvent( FstQueue, &Event, (unsigned)CTA_WAIT_FOREVER );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaWaitEvent" );
    }


    if (( Event.id != CTAEVN_OPEN_SERVICES_DONE )  || ( Event.value != CTA_REASON_FINISHED ))
    {
           ErrorAndExit( Ret, "ctaWaitEvent" );
    }
    else
       printf("Bind Confirmation Received and TUP Service Opened\n");

    while ( inloop)
    {
        /* cta wait event */
        Ret = ctaWaitEvent( FstQueue, &Event, 100 );
        if ( Ret != SUCCESS )
        {
                ErrorAndExit( Ret, "ctaWaitEvent" );
        }
        switch ( Event.id )
        {
            case TUPEVN_DATA:
               /*  an TUP event has occured, call TUPRetrieveMessage() to get the event */
               handleTupMessage(FstCtaHd);
               break;

            case TUPEVN_CONGEST:
                printf("Congestion event received: Congestion level: [%d]\n", Event.value);
                Ret = TUPGetApiStats( FstCtaHd, &apiStats, 0 );
                if ( Ret != SUCCESS) {
                   printf("TUPGetApiStats() fialed: error= %d\n", Ret);
                   break;
                }
                printf("Events Received:%d\n", apiStats.rxSuccess);
                printf("Successful transmit requests:%d\n", apiStats.txSuccess);
                printf("Outstanding transmit requests:%d\n", apiStats.txPending);
                break;

            case CTAEVN_WAIT_TIMEOUT:
            /* 5 seconds passed, check for keyboard input */
                /* make sure a key was hit */
                if (_kbhit())
                {
                    c = _getch();

                    if (c == 'q')
                      inloop = 0;
                    else if (c == 'r')
                      /*-----------------12/28/99 10:19AM-----------------
                       * Send the release request message
                       * --------------------------------------------------*/
                       sendReleaseReq(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
                    else if (c == 'k')
                       sendBlockReq(FstCtaHd, boardNum, SAP_ID, 0, 0, circuit);
                    else if (c == 'u')
                       sendUnblockReq(FstCtaHd, boardNum, SAP_ID, 0, 0, circuit);
                    else if (c == 'c')
                       sendCircuitResetReq(FstCtaHd, boardNum, SAP_ID, 0, 0, circuit);
                    else if (c == 'g')
                       sendGrpCircuitResetReq(FstCtaHd, boardNum, SAP_ID, 0, 0, circuit);
                    else if (c == 't')
                       sendContinuityCheckReq(FstCtaHd, boardNum, SAP_ID, 0, 0, circuit);
                    else if (c == 'f')
                       sendContinuityFailure(FstCtaHd, boardNum, SAP_ID, 0, 0, circuit);
                    else if (c == 's')
                       sendReleaseRsp(FstCtaHd, boardNum, &rcvEvent.m.relEvnt, &rcvInfo);
                    else if (c == 'h')
                       sendHardwareCirGrpBlkReq(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
                    else if (c == 'a')
                       sendHwCirGrpUnBlkReq(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
                    else if (c == 'm')
                       sendMaintCirGrpBlkReq(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
                    else if(c == 'n')
                       sendMaintCirGrpUnBlkReq(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'z')
					   sendSwitchEqpCongestion(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'y')
					   sendCirGrpCongestion(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'x')
					   sendNationNwkCongestion(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'w')
					   sendAddrIncomplete(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'v')
					   sendCallFailure(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'b')
					   sendSubscriberBusy(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'o')
					   sendUnallocatedNumber(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'l')
					   sendLineOutOfSerivce(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'j')
					   sendSpecialInfoTone(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'i')
					   sendAccessBarred(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'e')
					   sendNoDigitalPath(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
					else if(c == 'd')
					   sendIAM(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
                    else if(c == 'p')
                       sendCBK(FstCtaHd, boardNum, suId, suInstId, spInstId, circuit);
                    else if(c == '2'){
                       Ret = TUPGetApiStats( FstCtaHd, &apiStats, 0 );
                       if ( Ret != SUCCESS) {
                          printf("TUPGetApiStats fialed: error= %d\n", Ret);
                          break;
                       }
                       printf("Events Received:%d\n", apiStats.rxSuccess);
                       printf("Successful transmit requests:%d\n", apiStats.txSuccess);
                       printf("Outstanding transmit requests:%d\n", apiStats.txPending);
                    }
                }
                break;

            default:
                printf( "CTAHD(0x%08X) : Unhandled event id (0x%x) during "
                        "wait.\nExiting...\n", Event.ctahd,
                        Event.id );
        } /* End of switch on Event.id */

    } /* end while */

    /*
     *   Close service and destroy context.
     */
    Ret = ctaCloseServices( FstCtaHd, tupCloseSvcLst, 1 );
    if ( Ret != SUCCESS )
    {
      ErrorAndExit( Ret, "ctaCloseServices" );
    }

    /* Wait for service close to complete. */
    Ret = ctaWaitEvent( FstQueue, &Event, (unsigned)CTA_WAIT_FOREVER );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaWaitEvent" );
    }
    if (( Event.id != CTAEVN_CLOSE_SERVICES_DONE )  || ( Event.value != CTA_REASON_FINISHED ))
    {
           ErrorAndExit( Ret, "ctaWaitEvent" );
    }

    Ret = ctaDestroyContext( FstCtaHd );

    if ( Ret != SUCCESS )
    {
      ErrorAndExit( Ret, "ctaDestroyContext" );
    }

    /* Wait for context close to complete. */
    Ret = ctaWaitEvent( FstQueue, &Event, (unsigned)CTA_WAIT_FOREVER );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaWaitEvent" );
    }
    if (( Event.id != CTAEVN_DESTROY_CONTEXT_DONE )  || ( Event.value != CTA_REASON_FINISHED ))
    {
           ErrorAndExit( Ret, "ctaWaitEvent" );
    }

    Ret = ctaDestroyQueue( FstQueue );
    if ( Ret != SUCCESS )
    {
           ErrorAndExit( Ret, "ctaDestroyQueue" );
    }

} /* end of main */
