/* tupdemo.h : tupdemo header file */

#define INST_ID     0
#define ENT_ID      20
#define SAP_ID      0


/* Messages from TUP thread to circuit threads */

#define IAM_MSG     CTA_USER_EVENT(0x00)
#define IAI_MSG     CTA_USER_EVENT(0x01)
#define ANN_MSG     CTA_USER_EVENT(0x02)
#define ANC_MSG     CTA_USER_EVENT(0x03)
#define ANU_MSG     CTA_USER_EVENT(0x04)
#define CLF_MSG     CTA_USER_EVENT(0x05)
#define RLG_MSG     CTA_USER_EVENT(0x06)
#define ACM_MSG     CTA_USER_EVENT(0x07)
#define SAM_MSG     CTA_USER_EVENT(0x08)
#define SAO_MSG     CTA_USER_EVENT(0x09)
#define RAN_MSG     CTA_USER_EVENT(0x0a)
#define CCR_MSG     CTA_USER_EVENT(0x0b)
#define COT_MSG     CTA_USER_EVENT(0x0c)
#define CCF_MSG     CTA_USER_EVENT(0x0d)
#define BLO_MSG     CTA_USER_EVENT(0x0e)
#define UBL_MSG     CTA_USER_EVENT(0x0f)
#define RSC_MSG     CTA_USER_EVENT(0x10)
#define GRS_MSG     CTA_USER_EVENT(0x11)
#define MGB_MSG     CTA_USER_EVENT(0x12)
#define MGU_MSG     CTA_USER_EVENT(0x13)
#define HGB_MSG     CTA_USER_EVENT(0x14)
#define HGU_MSG     CTA_USER_EVENT(0x15)
#define SEC_MSG     CTA_USER_EVENT(0x16)
#define CGC_MSG     CTA_USER_EVENT(0x17)
#define NNC_MSG     CTA_USER_EVENT(0x18)
#define ADI_MSG     CTA_USER_EVENT(0x19)
#define CFL_MSG     CTA_USER_EVENT(0x1a)
#define SSB_MSG     CTA_USER_EVENT(0x1b)
#define UNN_MSG     CTA_USER_EVENT(0x1c)
#define LOS_MSG     CTA_USER_EVENT(0x1d)
#define SST_MSG     CTA_USER_EVENT(0x1e)
#define ACB_MSG     CTA_USER_EVENT(0x1f)
#define DPN_MSG     CTA_USER_EVENT(0x20)
#define CBK_MSG     CTA_USER_EVENT(0x21)
#define SGB_MSG     CTA_USER_EVENT(0x22)
#define SGU_MSG     CTA_USER_EVENT(0x23)

/* Event between circuit threads */

#define IAM_EVT     CTA_USER_EVENT(0x30)
#define IAI_EVT     CTA_USER_EVENT(0x31)
#define ANN_EVT     CTA_USER_EVENT(0x32)
#define ANC_EVT     CTA_USER_EVENT(0x33)
#define ANU_EVT     CTA_USER_EVENT(0x34)
#define CLF_EVT     CTA_USER_EVENT(0x35)
#define RLG_EVT     CTA_USER_EVENT(0x36)
#define ACM_EVT     CTA_USER_EVENT(0x37)
#define SAM_EVT     CTA_USER_EVENT(0x38)
#define SAO_EVT     CTA_USER_EVENT(0x39)
#define RAN_EVT     CTA_USER_EVENT(0x3a)
#define CCR_EVT     CTA_USER_EVENT(0x3b)
#define COT_EVT     CTA_USER_EVENT(0x3c)
#define CCF_EVT     CTA_USER_EVENT(0x3d)
#define BLO_EVT     CTA_USER_EVENT(0x3e)
#define UBL_EVT     CTA_USER_EVENT(0x3f)
#define RSC_EVT     CTA_USER_EVENT(0x40)
#define GRS_EVT     CTA_USER_EVENT(0x41)
#define MGB_EVT     CTA_USER_EVENT(0x42)
#define MGU_EVT     CTA_USER_EVENT(0x43)
#define HGB_EVT     CTA_USER_EVENT(0x44)
#define HGU_EVT     CTA_USER_EVENT(0x45)
#define SEC_EVT     CTA_USER_EVENT(0x46)
#define CGC_EVT     CTA_USER_EVENT(0x47)
#define NNC_EVT     CTA_USER_EVENT(0x48)
#define ADI_EVT     CTA_USER_EVENT(0x49)
#define CFL_EVT     CTA_USER_EVENT(0x4a)
#define SSB_EVT     CTA_USER_EVENT(0x4b)
#define UNN_EVT     CTA_USER_EVENT(0x4c)
#define LOS_EVT     CTA_USER_EVENT(0x4d)
#define SST_EVT     CTA_USER_EVENT(0x4e)
#define ACB_EVT     CTA_USER_EVENT(0x4f)
#define DPN_EVT     CTA_USER_EVENT(0x50)
#define CBK_EVT     CTA_USER_EVENT(0x51)
#define SGB_EVT     CTA_USER_EVENT(0x52)
#define SGU_EVT     CTA_USER_EVENT(0x53)

/* Events from HMI */

#define ERR_EVT         CTA_USER_EVENT(0x60)
#define DEAD_EVT        CTA_USER_EVENT(0x61)
#define STARTED_EVT     CTA_USER_EVENT(0x62)
#define BACKUP_EVT      CTA_USER_EVENT(0x63)
#define PRIMARY_EVT     CTA_USER_EVENT(0x64)
#define STANDALONE_EVT  CTA_USER_EVENT(0x65)

/* Events from UDP thread to circuit threads */
#define CHKPNT_EVT      CTA_USER_EVENT(0x66)
#define APPREADY_EVT    CTA_USER_EVENT(0x68)

#define IDLE_EVT        CTA_USER_EVENT(0x67)
#define APPREADY_EVT    CTA_USER_EVENT(0x68)
#define STOP_EVT        CTA_USER_EVENT(0x69)

#define EVT_TRACE       0x0001
#define CHKPNT_TRACE    0x0002


#define CHKPNT_MSG  0x434b5054
#define APPRDY_MSG  0x41524459

#define DIR_TX          1
#define DIR_RX          2

/* Incoming Thread States */
#define INCST_IDLE          0
#define INCST_WT4ACMEVT     1
#define INCST_WT4ANSWEREVT  2
#define INCST_CONNECTED     3
#define INCST_WT4CLFMSG     4
#define INCST_WT4RLGEVT     5

#define INC_MAXSTATES       6

/* Outgoing Thread States */
#define OUTST_IDLE          0
#define OUTST_WT4ACMMSG     1
#define OUTST_WT4ANSWERMSG  2
#define OUTST_CONNECTED     3
#define OUTST_WT4RLGMSG     4

#define OUT_MAXSTATES       5

/* circuitState values */
#define  IDLE_STATE                      0x201
#define  IDLE_LOC_BLK                    0x202
#define  IDLE_REM_BLK                    0x203
#define  IDLE_BOTH_BLK                   0x204
#define  BUSY_IN                         0x205
#define  BUSY_IN_LOC_BLK                 0x206
#define  BUSY_IN_REM_BLK                 0x207
#define  BUSY_IN_BOTH_BLK                0x208
#define  BUSY_OUT                        0x209
#define  BUSY_OUT_LOC_BLK                0x20a
#define  BUSY_OUT_REM_BLK                0x20b
#define  BUSY_OUT_BOTH_BLK               0x20c
#define  OOS_L                           0x20d
#define  OOS_L_LOC_BLK                   0x20e
#define  OOS_L_REM_BLK                   0x20f
#define  OOS_L_BOTH_BLK                  0x210
#define  OOS_R                           0x211
#define  OOS_R_LOC_BLK                   0x212
#define  OOS_R_REM_BLK                   0x213
#define  OOS_R_BOTH_BLK                  0x214
#define  OOS_B                           0x215
#define  OOS_B_LOC_BLK                   0x216
#define  OOS_B_REM_BLK                   0x217
#define  OOS_B_BOTH_BLK                  0x218

/* callState values for inbound and outbound circuits */
#define NOT_APPL                         0
/*If an inbound busy circuit */
#define WAIT_CNI_CLF                     0x301
#define WAIT_CNI_INFO                    0x302
#define WAIT_CNI_ANSWER                  0x303
#define WAIT_CNI_ACM                     0x304
#define WAIT_CNI_LOCAL_RLG               0x305
#define WAIT_CNI_COT                     0x306
#define WAIT_CNI_CCR                     0x307
#define WAIT_CNI_CONT_CLF                0x308
#define CNI_DEAD                         0x309
/* If an outgoing busy circuit */
#define WAIT_CNO_RLG                     0x401
#define WAIT_CNO_RELEASE                 0x402
#define WAIT_CNO_INFO                    0x403
#define WAIT_CNO_ANSWER                  0x404
#define WAIT_CNO_ACM                     0x405
#define WAIT_CNO_COT                     0x406
#define WAIT_CNO_CONT_CLF                0x407
#define WAIT_CNO_CCR                     0x408
#define CNO_DEAD                         0x409

typedef struct checkPointMsg
{
    U32      msgId;
    CirIdx   cirId;
    CirIdx   mateId;
    U16	     state;
    U16      callState;
    U16	     circuitState;
} ChkPntMsg;

typedef struct
{
    TupRcvInfoBlk  info;
    TupAllSdus     sdu;
    ChkPntMsg      chkPntMsg;
} Event;

typedef struct circuit
{
	CTAQUEUEHD      ctaQueue;
	CTAHD           ctaHndl;
	CirIdx          cirId;
	CirIdx          mateId;
    U16             state;
    U16             callState;
	U16             circuitState;
} Circuit;

typedef struct
{
    char               *stateName;  /*  Circuit/call state name */
    void              (*state)();    /* pointer to state function */
} StateDesc;

